=== Platforms/CMakeLists.txt ===
mygui_set_platform_name(${MYGUI_RENDERSYSTEM})

add_subdirectory(${MYGUI_PLATFORM_NAME}/${MYGUI_PLATFORM_NAME}Platform)
