=== Plugins/Plugin_StrangeButton/CMakeLists.txt ===
mygui_plugin(Plugin_StrangeButton)
