=== Tools/EditorFramework/CMakeLists.txt ===
mygui_tool_dll(EditorFramework)
set_source_files_properties(pugixml.cpp PROPERTIES COMPILE_FLAGS -w)
