=== Tools/ImageEditor/CMakeLists.txt ===
mygui_tool(ImageEditor)
