=== debian/changelog ===
mygui (3.4.1+dfsg-3) unstable; urgency=medium

  * Team upload
  * libmygui-dev: Add missing Depends (Closes: #1035453)

 -- Bastian Germann <bage@debian.org>  Fri, 12 May 2023 19:29:44 +0200

mygui (3.4.1+dfsg-2) unstable; urgency=medium

  * Team upload
  * Let uscan repack automatically

  [ Bret Curtis ]
  * Make this a team-maintained package

 -- Bastian Germann <bage@debian.org>  Tue, 06 Sep 2022 18:22:04 +0200

mygui (3.4.1+dfsg-1) unstable; urgency=medium

  [ Bret Curtis ]
  * New upstream release (3.4.1)
  * Stripped windows binaries from source, making it dfsg
  * Added new OpenGL3 rendering target
  * Updated symbols files

  [ Steve Langesek ]
  * Resolved ftbfs with GCC-11 (Closes: #984248)

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Set upstream metadata fields: Bug-Database, Bug-Submit.
  * Use canonical URL in Vcs-Git.
  * Remove unnecessary get-orig-source-target.  

 -- Bret Curtis <psi29a@gmail.com>  Tue, 02 Mar 2021 13:30:43 +0100
