=== debian/watch ===
version=3
opts=repacksuffix=+dfsg,dversionmangle=s/(\da?)[\+\.\-~](?:dfsg|debian|ds|repack|repacked)\.?\d*$/$1/ \
https://github.com/MyGUI/mygui/releases .*/MyGUI([\d\.]*)\.tar.gz
