=== Tools/CMakeLists.txt ===
add_subdirectory(EditorFramework)
add_subdirectory(LayoutEditor)
add_subdirectory(SkinEditor)
add_subdirectory(ImageEditor)
add_subdirectory(FontEditor)
