=== Demos/Demo_Console/CMakeLists.txt ===
mygui_demo(Demo_Console)
