=== Demos/Demo_Picking/CMakeLists.txt ===
mygui_demo(Demo_Picking)
