=== Wrappers/MyGUI_RenderWindow_Export/CMakeLists.txt ===
mygui_app(MyGUI_RenderWindow_Export Wrappers)
