=== Platforms/DirectX/DirectXPlatform/CMakeLists.txt ===
--- 
+++ 
@@ -18,6 +18,6 @@
 
 # installation rules
 install(FILES ${HEADER_FILES}
-	DESTINATION include/MYGUI
+	DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/MYGUI"
 )
 mygui_install_target(${PROJECTNAME} "")
