=== debian/changelog ===
mygui (3.4.2+dfsg-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1063154

 -- Benjamin Drung <bdrung@debian.org>  Wed, 28 Feb 2024 21:40:30 +0000

mygui (3.4.2+dfsg-1) unstable; urgency=medium

  * Team upload.

  [ Bret Curtis ]
  * Import new upstream version 3.4.2.
  * Update patch file.
  * Fix uscan to scan GitHub tags.
  * Move Build-Depends to libfreetype-dev and libgl-dev.

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster (oldstable):
    + Build-Depends: Drop versioned constraint on g++ and libfreetype6-dev.
  * Trim trailing whitespace.
  * Set upstream metadata fields: Archive, Repository-Browse.
  * Update standards version to 4.6.1, no changes needed.

 -- Bastian Germann <bage@debian.org>  Mon, 12 Jun 2023 15:30:17 +0200
