=== debian/control ===
--- 
+++ 
@@ -2,11 +2,11 @@
 Priority: optional
 Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders: Bret Curtis <psi29a@gmail.com>
-Build-Depends: cmake, doxygen, debhelper-compat (= 13), g++ (>= 4:7),
- libogre-1.12-dev, pkg-kde-tools, libfreetype6-dev (>= 2.5.1),
- pkg-config, graphviz, libgl1-mesa-dev, libglew-dev, libois-dev
+Build-Depends: dpkg-dev (>= 1.22.5), cmake, doxygen, debhelper-compat (= 13),
+ libogre-1.12-dev, pkg-kde-tools, libfreetype-dev,
+ pkg-config, graphviz, libgl-dev, libglew-dev, libois-dev
 Homepage: http://www.ogre3d.org/tikiwiki/MyGUI
-Standards-Version: 4.5.1
+Standards-Version: 4.6.1
 Section: libs
 Vcs-Browser: https://salsa.debian.org/games-team/mygui
 Vcs-Git: https://salsa.debian.org/games-team/mygui.git
@@ -15,10 +15,10 @@
 Section: libdevel
 Architecture: any
 Depends: ${misc:Depends},
- libmyguiengine3debian1v5 (= ${binary:Version}),
- libmygui.ogreplatform0debian1v5 (= ${binary:Version}),
- libmygui.opengl3platform0debian1v5 (= ${binary:Version}),
- libmygui.openglplatform0debian1v5 (= ${binary:Version})
+ libmyguiengine3debian1t64 (= ${binary:Version}),
+ libmygui.ogreplatform0debian1t64 (= ${binary:Version}),
+ libmygui.opengl3platform0debian1t64 (= ${binary:Version}),
+ libmygui.openglplatform0debian1t64 (= ${binary:Version})
 Suggests: mygui-doc
 Description: Fast, simple and flexible GUI for OpenMW - development files
  MyGUI is a GUI library which aims to be fast, flexible and simple GUIs in C++.
@@ -44,10 +44,13 @@
  This package contains the headers and static libraries needed to develop
  programs using MyGUI.
 
-Package: libmyguiengine3debian1v5
+Package: libmyguiengine3debian1t64
+Provides: ${t64:Provides}
+X-Time64-Compat: libmyguiengine3debian1v5
+Breaks: libmyguiengine3debian1v5 (<< ${source:Version})
 Architecture: any
 Conflicts: libmyguiengine3debian1
-Replaces: libmyguiengine3debian1
+Replaces: libmyguiengine3debian1v5, libmyguiengine3debian1
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: Fast, simple and flexible GUI - shared library
  MyGUI is a GUI library which aims to be fast, flexible and simple GUIs in C++.
@@ -72,10 +75,13 @@
  .
  This package contains the MyGUI runtime engine.
 
-Package: libmygui.ogreplatform0debian1v5
+Package: libmygui.ogreplatform0debian1t64
+Provides: ${t64:Provides}
+X-Time64-Compat: libmygui.ogreplatform0debian1v5
+Breaks: libmygui.ogreplatform0debian1v5 (<< ${source:Version})
 Architecture: any
 Conflicts: libmygui.ogreplatform0debian1
-Replaces: libmygui.ogreplatform0debian1
+Replaces: libmygui.ogreplatform0debian1v5, libmygui.ogreplatform0debian1
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: Fast, simple and flexible GUI - Ogre interface
  MyGUI is a GUI library which aims to be fast, flexible and simple GUIs in C++.
@@ -100,10 +106,13 @@
  .
  This package contains the MyGUI interface to the Ogre graphics engine.
 
-Package: libmygui.openglplatform0debian1v5
+Package: libmygui.openglplatform0debian1t64
+Provides: ${t64:Provides}
+X-Time64-Compat: libmygui.openglplatform0debian1v5
+Breaks: libmygui.openglplatform0debian1v5 (<< ${source:Version})
 Architecture: any
 Conflicts: libmygui.openglplatform0debian1
-Replaces: libmygui.openglplatform0debian1
+Replaces: libmygui.openglplatform0debian1v5, libmygui.openglplatform0debian1
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: Fast, simple and flexible GUI - OpenGL interface
  MyGUI is a GUI library which aims to be fast, flexible and simple GUIs in C++.
@@ -128,10 +137,13 @@
  .
  This package contains the MyGUI interface for OpenGL.
 
-Package: libmygui.opengl3platform0debian1v5
+Package: libmygui.opengl3platform0debian1t64
+Provides: ${t64:Provides}
+X-Time64-Compat: libmygui.opengl3platform0debian1v5
+Breaks: libmygui.opengl3platform0debian1v5 (<< ${source:Version})
 Architecture: any
 Conflicts: libmygui.opengl3platform0debian1
-Replaces: libmygui.opengl3platform0debian1
+Replaces: libmygui.opengl3platform0debian1v5, libmygui.opengl3platform0debian1
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: Fast, simple and flexible GUI - OpenGL3 interface
  MyGUI is a GUI library which aims to be fast, flexible and simple GUIs in C++.
